GET/projects/api/v3/reporting/custom/{id}/data.json

Get a custom report's data.

Returns the data rows for the custom report. When reportFormat is set, an export (csv, xlsx, pdf, html, googlesheets) is generated instead of the JSON response; google sheets exports return a redirect to the spreadsheet.

Path Params

  • Name
    id
    Type
    integer
    required
    Description

Query Params

  • Name
    searchTerm
    Type
    string
    Description

    filter by search term

  • Name
    reportFormat
    Type
    string
    Description

    define the format of the report

    Allowed values
    • html
    • pdf
    • xlsx
    • csv
  • Name
    orderMode
    Type
    string
    Description

    order mode

    Default
    asc
    Allowed values
    • asc
    • desc
  • Name
    cursor
    Type
    string
    Description

    cursor to control the pagination.

  • Name
    orderByPosition
    Type
    integer
    Description

    order by column position

  • Name
    limit
    Type
    integer
    Description

    number of items to show.

    Default
    100
  • Name
    includeEntityID
    Type
    boolean
    Description

    include entity ID in the response

  • Name
    customFieldsSiteLevelOnly
    Type
    boolean
    Description

    filter by custom fields at site level only

    Default
    true
  • Name
    selectedColumns
    Type
    array[string]
    Description

    determine the columns to be included in the report

    Default
    all
    Format
    Comma separated values
  • Name
    include
    Type
    array[string]
    Description

    include (not used when generating exports)

    Format
    Comma separated values
    Allowed values
    • customReports
    • customfields
  • Name
    fields[customfields]
    Type
    array[string]
    Description
    Format
    Comma separated values
    Allowed values
    • id
    • projectId
    • entity
    • name
    • description
    • type
    • options
    • visibilities
    • isPrivate
    • required
    • createdAt
    • createdByUserId
    • updatedAt
    • updatedByUserId
    • deleted
    • deletedAt
    • deletedByUserId
  • Name
    fields[customReports]
    Type
    array[string]
    Description
    Format
    Comma separated values
    Allowed values
    • id
    • baseType
    • status
    • name
    • startAt
    • lastGeneratedAt
    • endAt
    • datePeriod
    • summary
    • ownedByUser
    • createdAt
    • createdByUser
    • updatedAt
    • updatedByUser
    • deletedAt
    • deletedByUser
    • grantAccessTo
    • columns
    • customfields
    • filters
    • sortByPosition
    • sortOrder

Responses

  • Code
    200
    Type
    object
    Schema
    Description
    200 OK
    DataResponse contains custom report data.
  • Code
    302
    Description
    302 Found No Data
  • Code
    400
    Type
    object
    Schema
    Description
    400 Bad Request
    ErrorResponse defines how []Error should be marshaled to JSON.
  • Code
    403
    Type
    object
    Schema
    Description
    403 Forbidden
    ErrorResponse defines how []Error should be marshaled to JSON.
  • Code
    404
    Type
    object
    Schema
    Description
    404 Not Found
    ErrorResponse defines how []Error should be marshaled to JSON.
  • Code
    423
    Type
    object
    Schema
    Description
    423 Locked
    ErrorResponse defines how []Error should be marshaled to JSON.

Examples

200 OK

DataResponse
{
  "customReportData": {
    "CustomReportID": 0,
    "Items": [
      {
        "Columns": [
          {
            "name": "string",
            "value": "Unknown Type: any"
          }
        ]
      }
    ],
    "Summary": [
      {
        "Columns": [
          {
            "name": "string",
            "value": "Unknown Type: any"
          }
        ]
      }
    ]
  },
  "included": {
    "customReports": {
      "additionalProp": {
        "advancedFilter": [
          "Unknown Type: any"
        ],
        "baseType": "string",
        "charts": [
          {
            "chartId": "string",
            "createdAt": "string",
            "createdByUser": 0,
            "name": "string",
            "order": 0,
            "reportId": 0,
            "series": [
              {
                "chartId": "string",
                "color": "string",
                "columnId": 0,
                "id": 0,
                "name": "string",
                "position": 0,
                "reportId": 0,
                "type": "string"
              }
            ],
            "updatedAt": "string",
            "updatedByUser": 0,
            "visible": true
          }
        ],
        "columns": [
          {
            "name": "string",
            "position": 0
          }
        ],
        "createdAt": "string",
        "createdByUser": {
          "id": 0,
          "meta": {},
          "type": "string"
        },
        "customfieldFilters": [
          {
            "id": 0,
            "operator": "string",
            "value": "string"
          }
        ],
        "customfields": [
          {
            "id": 0,
            "position": 0
          }
        ],
        "datePeriod": 0,
        "deletedAt": "string",
        "deletedByUser": {
          "id": 0,
          "meta": {},
          "type": "string"
        },
        "description": "string",
        "endAt": "2026-05-20",
        "filters": [
          {
            "name": "string",
            "type": "string",
            "value": "Unknown Type: any"
          }
        ],
        "grantAccessTo": {
          "companies": [
            {
              "company": {
                "id": 0,
                "meta": {},
                "type": "string"
              },
              "createdAt": "string",
              "createdByUser": {
                "id": 0,
                "meta": {},
                "type": "string"
              },
              "updatedAt": "string",
              "updatedByUser": {
                "id": 0,
                "meta": {},
                "type": "string"
              }
            }
          ],
          "teams": [
            {
              "createdAt": "string",
              "createdByUser": {
                "id": 0,
                "meta": {},
                "type": "string"
              },
              "team": {
                "id": 0,
                "meta": {},
                "type": "string"
              },
              "updatedAt": "string",
              "updatedByUser": {
                "id": 0,
                "meta": {},
                "type": "string"
              }
            }
          ],
          "users": [
            {
              "createdAt": "string",
              "createdByUser": {
                "id": 0,
                "meta": {},
                "type": "string"
              },
              "starred": true,
              "updatedAt": "string",
              "updatedByUser": {
                "id": 0,
                "meta": {},
                "type": "string"
              },
              "user": {
                "id": 0,
                "meta": {},
                "type": "string"
              }
            }
          ]
        },
        "id": 0,
        "lastGeneratedAt": "string",
        "name": "string",
        "ownedByUser": {
          "id": 0,
          "meta": {},
          "type": "string"
        },
        "perspectiveConfig": "string",
        "sortByPosition": 0,
        "sortOrder": "string",
        "starred": true,
        "startAt": "2026-05-20",
        "status": "string",
        "summary": true,
        "updatedAt": "string",
        "updatedByUser": {
          "id": 0,
          "meta": {},
          "type": "string"
        }
      }
    },
    "customfields": {
      "additionalProp": {
        "createdAt": "string",
        "createdBy": 0,
        "createdByUserId": 0,
        "currencyCode": "string",
        "deleted": true,
        "deletedAt": "string",
        "deletedBy": 0,
        "deletedByUserId": 0,
        "description": "string",
        "entity": "string",
        "formula": "string",
        "groupId": 0,
        "id": 0,
        "isPrivate": true,
        "name": "string",
        "options": "Unknown Type: any",
        "project": {
          "id": 0,
          "meta": {},
          "type": "string"
        },
        "projectId": 0,
        "required": true,
        "type": "string",
        "unitId": 0,
        "updatedAt": "string",
        "updatedBy": 0,
        "updatedByUserId": 0,
        "visibilities": [
          "string"
        ]
      }
    }
  },
  "meta": {
    "averageSpend": 0,
    "data": {},
    "limit": 0,
    "nextCursor": "string",
    "page": {
      "count": 0,
      "hasMore": true,
      "pageOffset": 0,
      "pageSize": 0
    },
    "prevCursor": "string",
    "totalCapacity": 0
  }
}